;-----------------------------------------------------------------------------------------------
;By Marc Plouhinec (URL: http://www.thebestof.tk email:m_plouhinec@yahoo.fr)
;Small program that explains how to play background music
;This prgram installs an interrupt that plays sound
;This software is an exemple for SNG programmers
;
;Caution : if this routine freezes or locks up your calc or VTI, leave off :
;
; LD DE,musique          ;--|Loads background music
; CALL NEW_INTERUPT      ;--|
;and
; LD A,0                 ;--|Stops background music
; CALL STOP_INTERUPT     ;--|
;and add in the main loop:
; CALL musique
;-----------------------------------------------------------------------------------------------
; translated by pacHa

#include "sngbeta.inc"
 .ORG START_ADDR
 .DB "Music example",0

 ROM_CALL(CLEARLCD)     ;clear the screen
 LD HL,0                ;
 LD (numnote),HL        ;
 LD DE,musique          ;--|Loads background music
 CALL NEW_INTERUPT      ;--|

loop:                 ;
 CALL affiche_numero_note
 ld      a,$FF          ;
 out     (1),a          ;
 ld      a,$FD          ;Wait for [CLEAR]
 out     (1),a          ; 
 in      a,(1)          ;
 and     %01000000      ;
 jr      nz,loop      ;go to loop until [CLEAR] is hit

 LD A,0                 ;--|Stops background music
 CALL STOP_INTERUPT     ;--|
 RET                    ;quits

affiche_numero_note:
 LD HL,0
 LD (CURSOR_POS),HL
 LD HL,(numnote)
 ROM_CALL(D_HL_DECI)
 RET

maxnote = 11
musique:                ;routine that plays music
 LD HL,(numnote)        ;--|
 LD DE,maxnote          ;  |Is it the last sound to play ?
 CALL CP_HL_DE          ;  |
 JR NZ,jouenote         ;--|
 LD HL,0                ;----|if it is, set (numnote) back to 0
 ld (numnote),HL        ;----|
jouenote:               ;
 LD HL,(compteur)       ;--|
 LD DE,50               ;  |Is the counter=100 ?
 CALL CP_HL_DE          ;  |
 JR NZ,changepasdenote  ;--|
 LD HL,0                ;----|
 LD (compteur),HL       ;    |Is it is, reset it
 LD HL,(numnote)        ;    |Load into (numnote) the # of the next sound
 INC HL                 ;    |
 LD (numnote),HL        ;----|
changepasdenote:        ;
 LD HL,(compteur)       ;--|
 INC HL                 ;  |Increase the counter
 LD (compteur),HL       ;--|
 LD HL,(numnote)        ;----|
 LD BC,2                ;    |
 CALL MUL_HL_BC         ;    |
 EX DE,HL               ;    |Load the sound into HL
 LD HL,buffernote       ;    |
 ADD HL,DE              ;    |
 CALL LD_HL_MHL         ;----|
 PUSH HL                ;--|
 ld b, 5                ;  |
SON_BOUCLE4:            ;  |
 POP HL                 ;  |
 PUSH HL                ;  |Play the sound in HL
 LD DE,100              ;  |
 call BEEP              ;  |
 djnz SON_BOUCLE4       ;  |
 POP HL                 ;--|
 RET                    ;

compteur .DW 0
numnote .DW 0
buffernote: .DW 100,200,300,400,500,600,700,800,900,1000,1100

.end
END